package de.accso.flexinale.data.model;

import de.accso.flexinale.application.KontingentBereitsAusgeschoepftException;
import de.accso.flexinale.shared_kernel.FlexinaleIllegalArgumentException;
import de.accso.flexinale.shared_kernel.Identifiable;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import java.io.Serializable;

@jakarta.persistence.Entity
public class Kontingent implements Identifiable, Serializable {

    public enum KontingentType {
        ONLINE,
        ZENTRAL,
        KINOKASSE
    }

    @jakarta.persistence.Id
    public String id;

    @jakarta.persistence.Column
    private Integer restKontingentOnline = 0;

    @jakarta.persistence.Column
    private Integer restKontingentZentral = 0;

    @jakarta.persistence.Column
    private Integer restKontingentKinokasse = 0;

    protected Kontingent() {
    }

    public Kontingent(final String id, final int gesamtKapazitaetVerkauf, final int quoteOnline) {
        this.id = id;

        restKontingentOnline = (int) Math.ceil((float)(gesamtKapazitaetVerkauf * quoteOnline)/100);
        restKontingentZentral = (int) Math.floor((float)(gesamtKapazitaetVerkauf - restKontingentOnline)/2);
        restKontingentKinokasse = gesamtKapazitaetVerkauf - restKontingentZentral - restKontingentOnline;
    }

    @Override
    public Id id() {
        return Identifiable.Id.of(id);
    }

    public Integer getRestKontingentOnline() {
        return restKontingentOnline;
    }

    public Integer getRestKontingentZentral() {
        return restKontingentZentral;
    }

    public Integer getRestKontingentKinokasse() {
        return restKontingentKinokasse;
    }

    public void reduziereKontingent(KontingentType kontingentType, int kontingentReduktion) {
        if (kontingentReduktion < 0) {
            throw new FlexinaleIllegalArgumentException("reduction of Kontingent has to be >=0 but is "
                    + kontingentReduktion);
        }

        switch (kontingentType) {
            case ONLINE ->
                    restKontingentOnline = reduziereDiesesKontingent(restKontingentOnline, kontingentReduktion);
            case ZENTRAL ->
                    restKontingentZentral = reduziereDiesesKontingent(restKontingentZentral, kontingentReduktion);
            case KINOKASSE ->
                    restKontingentKinokasse = reduziereDiesesKontingent(restKontingentKinokasse, kontingentReduktion);
        }
    }

    private int reduziereDiesesKontingent(final int kontingent, final int reduziereUm) {
        int reduziertesKontingent = kontingent - reduziereUm;
        if (reduziertesKontingent < 0) {
            throw new KontingentBereitsAusgeschoepftException();
        }
        return reduziertesKontingent;
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public boolean equals(final Object o) {
        if (this == o) {return true;}

        if (o == null || getClass() != o.getClass()) {return false;}

        Kontingent that = (Kontingent) o;

        return new EqualsBuilder().append(id, that.id)
                .append(restKontingentOnline, that.restKontingentOnline)
                .append(restKontingentZentral, that.restKontingentZentral)
                .append(restKontingentKinokasse, that.restKontingentKinokasse)
                .isEquals();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder(17, 37)
                .append(id)
                .append(restKontingentOnline).append(restKontingentZentral).append(restKontingentKinokasse)
                .toHashCode();
    }
}
